gtkmm: Gtk::TreeViewColumn Class Reference

# Gtk::TreeViewColumn Class Reference
[TreeView Classes]

Typedefed as Gtk::TreeView::Column. More...

Inherits Gtk::Object.

Collaboration diagram for Gtk::TreeViewColumn:
[legend]

List of all members.

## Public Types
typedef TreeViewColumn | Column
typedef sigc::slot< void, CellRenderer*, const Gtk::TreeModel::iterator& > | SlotCellData
| For instance, void on_cell_data(Gtk::CellRenderer* cell, const Gtk::TreeModel::iterator& iter);.
## Public Member Functions
virtual | ~TreeViewColumn ()
GtkTreeViewColumn* | gobj ()
| Provides access to the underlying C GtkObject.
const GtkTreeViewColumn* | gobj () const
| Provides access to the underlying C GtkObject.
| TreeViewColumn ()
| TreeViewColumn (const Glib::ustring& title)
| TreeViewColumn (const Glib::ustring& title, CellRenderer& cell)
template<class T_ModelColumnType >
| TreeViewColumn (const Glib::ustring& title, const TreeModelColumn< T_ModelColumnType >& column)
| Create a default view column for the given model column type.
void | pack_start (CellRenderer& cell, bool expand=true)
| Packs the cell into the beginning of the column.
void | pack_end (CellRenderer& cell, bool expand=true)
| Adds the cell to end of the column.
template<class T_ModelColumnType >
void | pack_start (const TreeModelColumn< T_ModelColumnType >& column, bool expand=true)
| Creates an appropriate CellRenderer for the column, and packs that cell into the beginning of the column.
template<class T_ModelColumnType >
void | pack_end (const TreeModelColumn< T_ModelColumnType >& column, bool expand=true)
| Creates an appropriate CellRenderer for the column, and packs that cell at the end of the column.
void | clear ()
| Unsets all the mappings on all renderers on the tree_column.
CellRenderer* | get_first_cell_renderer ()
| Gets the CellRenderer for the column.
const CellRenderer* | get_first_cell_renderer () const
| Gets the CellRenderer for the column.
Glib::ListHandle< CellRenderer* > | get_cell_renderers ()
| Returns a list of all the cell renderers in the column, in no particular order.
Glib::ListHandle< const CellRenderer* > | get_cell_renderers () const
| Returns a list of all the cell renderers in the column, in no particular order.
void | add_attribute (CellRenderer& cell_renderer, const Glib::ustring& attribute, int column)
| Adds an attribute mapping to the list in tree_column.
void | add_attribute (const Glib::PropertyProxy_Base& property, const TreeModelColumnBase& column)
void | add_attribute (Gtk::CellRenderer& cell, const Glib::ustring& property_name, const TreeModelColumnBase& column)
void | set_renderer (Gtk::CellRenderer& renderer, const TreeModelColumnBase& column)
| Associate a view CellRenderer with a model column, so that the CellRenderer renders the data in the model column.
void | set_cell_data_func (CellRenderer& cell_renderer, const SlotCellData& slot)
| Sets the slot callback to use for the column.
void | unset_cell_data_func (CellRenderer& cell_renderer)
| Removes a previously set callback slot.
void | clear_attributes (CellRenderer& cell_renderer)
| Clears all existing attributes previously set with set_attributes().
void | set_spacing (int spacing)
| Sets the spacing field of tree_column, which is the number of pixels to place between cell renderers packed into it.
int | get_spacing () const
| Returns the spacing of tree_column.
void | set_visible (bool visible=true)
| Sets the visibility of tree_column.
bool | get_visible () const
| Returns `true` if tree_column is visible.
void | set_resizable (bool resizable=true)
| If resizable is `true`, then the user can explicitly resize the column by grabbing the outer edge of the column button.
bool | get_resizable () const
| Returns `true` if the tree_column can be resized by the end user.
void | set_sizing (TreeViewColumnSizing type)
| Sets the growth behavior of tree_column to type.
TreeViewColumnSizing | get_sizing ()
| Returns the current type of tree_column.
int | get_width () const
| Returns the current size of tree_column in pixels.
int | get_fixed_width () const
| Gets the fixed width of the column.
void | set_fixed_width (int fixed_width)
| Sets the size of the column in pixels.
void | set_min_width (int min_width)
| Sets the minimum width of the tree_column.
int | get_min_width () const
| Returns the minimum width in pixels of the tree_column, or -1 if no minimum width is set.
void | set_max_width (int max_width)
| Sets the maximum width of the tree_column.
int | get_max_width () const
| Returns the maximum width in pixels of the tree_column, or -1 if no maximum width is set.
void | clicked ()
| Emits the "clicked" signal on the column.
void | set_title (const Glib::ustring& title)
| Sets the title of the tree_column.
Glib::ustring | get_title () const
| Returns the title of the widget.
void | set_expand (bool expand=true)
| Sets the column to take available extra space.
bool | get_expand () const
| Return `true` if the column expands to take any available space.
void | set_clickable (bool clickable=true)
| Sets the header to be active if active is `true`.
bool | get_clickable () const
| Returns `true` if the user can click on the header for the column.
void | set_widget (Gtk::Widget& widget)
| Sets the widget in the header to be widget.
Widget* | get_widget ()
| Returns the Gtk::Widget in the button on the column header.
const Widget* | get_widget () const
| Returns the Gtk::Widget in the button on the column header.
void | set_alignment (float xalign)
| Sets the alignment of the title or custom widget inside the column header.
void | set_alignment (AlignmentEnum xalign)
| Sets the alignment of the title or custom widget inside the column header.
float | get_alignment () const
| Returns the current x alignment of tree_column.
void | set_reorderable (bool reorderable=true)
| If reorderable is `true`, then the column can be reordered by the end user dragging the header.
bool | get_reorderable () const
| Returns `true` if the tree_column can be reordered by the user.
void | set_sort_column (const TreeModelColumnBase& sort_column_id)
| Sets the logical sort_column_id that this column sorts on when this column is selected for sorting.
void | set_sort_column (int sort_column_id)
| Sets the logical sort_column_id that this column sorts on when this column is selected for sorting.
void | set_sort_column_id (const TreeModelColumnBase& sort_column_id)
void | set_sort_column_id (int sort_column_id)
int | get_sort_column_id () const
| Gets the logical sort_column_id that the model sorts on when this column is selected for sorting.
void | set_sort_indicator (bool setting)
| Call this function with a setting of `true` to display an arrow in the header button indicating the column is sorted.
bool | get_sort_indicator () const
| Gets the value set by set_sort_indicator().
void | set_sort_order (SortType order)
| Changes the appearance of the sort indicator.
SortType | get_sort_order () const
| Gets the value set by set_sort_order().
void | cell_set_cell_data (const Glib::RefPtr< TreeModel >& tree_model, const TreeModel::iterator& iter, bool is_expander, bool is_expanded)
| Sets the cell renderer based on the tree_model and iter.
void | cell_get_size (Gdk::Rectangle& cell_area, int& x_offset, int& y_offset, int& width, int& height) const
| Obtains the width and height needed to render the column.
void | cell_get_size (const Gdk::Rectangle& cell_area, int& x_offset, int& y_offset, int& width, int& height) const
| Obtains the width and height needed to render the column.
bool | cell_is_visible () const
| Returns `true` if any of the cells packed into the tree_column are visible.
void | focus_cell (CellRenderer& cell)
| Sets the current keyboard focus to be at cell, if the column contains 2 or more editable and activatable cells.
bool | get_cell_position (const CellRenderer& cell_renderer, int& start_pos, int& width) const
| Obtains the horizontal position and size of a cell in a column.
void | queue_resize ()
| Flags the column, and the cell renderers added to this column, to have their sizes renegotiated.
TreeView* | get_tree_view ()
| Returns the Gtk::TreeView wherein tree_column has been inserted.
const TreeView* | get_tree_view () const
| Returns the Gtk::TreeView wherein tree_column has been inserted.
Glib::SignalProxy0< void > | signal_clicked ()
Glib::PropertyProxy< bool > | property_visible ()
| Whether to display the column.
Glib::PropertyProxy_ReadOnly < bool > | property_visible () const
| Whether to display the column.
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| Current width of the column.
Glib::PropertyProxy < TreeViewColumnSizing > | property_sizing ()
| Resize mode of the column.
Glib::PropertyProxy_ReadOnly < TreeViewColumnSizing > | property_sizing () const
| Resize mode of the column.
Glib::PropertyProxy< int > | property_fixed_width ()
| Current fixed width of the column.
Glib::PropertyProxy_ReadOnly< int > | property_fixed_width () const
| Current fixed width of the column.
Glib::PropertyProxy< int > | property_min_width ()
| Minimum allowed width of the column.
Glib::PropertyProxy_ReadOnly< int > | property_min_width () const
| Minimum allowed width of the column.
Glib::PropertyProxy< int > | property_max_width ()
| Maximum allowed width of the column.
Glib::PropertyProxy_ReadOnly< int > | property_max_width () const
| Maximum allowed width of the column.
Glib::PropertyProxy < Glib::ustring > | property_title ()
| Title to appear in column header.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_title () const
| Title to appear in column header.
Glib::PropertyProxy< bool > | property_expand ()
| Column gets share of extra width allocated to the widget.
Glib::PropertyProxy_ReadOnly < bool > | property_expand () const
| Column gets share of extra width allocated to the widget.
Glib::PropertyProxy< bool > | property_clickable ()
| Whether the header can be clicked.
Glib::PropertyProxy_ReadOnly < bool > | property_clickable () const
| Whether the header can be clicked.
Glib::PropertyProxy< Widget* > | property_widget ()
| Widget to put in column header button instead of column title.
Glib::PropertyProxy_ReadOnly < Widget* > | property_widget () const
| Widget to put in column header button instead of column title.
Glib::PropertyProxy< float > | property_alignment ()
| X Alignment of the column header text or widget.
Glib::PropertyProxy_ReadOnly < float > | property_alignment () const
| X Alignment of the column header text or widget.
Glib::PropertyProxy< bool > | property_reorderable ()
| Whether the column can be reordered around the headers.
Glib::PropertyProxy_ReadOnly < bool > | property_reorderable () const
| Whether the column can be reordered around the headers.
Glib::PropertyProxy< bool > | property_sort_indicator ()
| Whether to show a sort indicator.
Glib::PropertyProxy_ReadOnly < bool > | property_sort_indicator () const
| Whether to show a sort indicator.
Glib::PropertyProxy< SortType > | property_sort_order ()
| Sort direction the sort indicator should indicate.
Glib::PropertyProxy_ReadOnly < SortType > | property_sort_order () const
| Sort direction the sort indicator should indicate.
## Protected Member Functions
virtual void | on_clicked ()
## Related Functions
(Note that these are not member functions.)
Gtk::TreeViewColumn* | wrap (GtkTreeViewColumn* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Typedefed as Gtk::TreeView::Column.

This is a visible column in a Gtk::TreeView widget. It determines the geometry, type.

## Member Typedef Documentation

typedef TreeViewColumn Gtk::TreeViewColumn::Column

typedef sigc::slot<void, CellRenderer*, const Gtk::TreeModel::iterator&> Gtk::TreeViewColumn::SlotCellData

For instance, void on_cell_data(Gtk::CellRenderer* cell, const Gtk::TreeModel::iterator& iter);.

This function is used instead of the standard attributes mapping for setting the column value, and should set the value of the column's cell renderer as appropriate.

## Constructor & Destructor Documentation

virtual Gtk::TreeViewColumn::~TreeViewColumn | ( |  | ) | `[virtual]`

Gtk::TreeViewColumn::TreeViewColumn | ( |  | ) |

Gtk::TreeViewColumn::TreeViewColumn | ( | const Glib::ustring & | title | ) | `[explicit]`

Gtk::TreeViewColumn::TreeViewColumn | ( | const Glib::ustring & | title,
|  | CellRenderer& | cell |
| ) |  |  |

template <class T_ModelColumnType >

Gtk::TreeViewColumn::TreeViewColumn | ( | const Glib::ustring & | title,
|  | const TreeModelColumn< T_ModelColumnType >& | column |
| ) |  |  | `[inline]`

Create a default view column for the given model column type.

## Member Function Documentation

void Gtk::TreeViewColumn::add_attribute | ( | Gtk::CellRenderer& | cell,
|  | const Glib::ustring & | property_name,
|  | const TreeModelColumnBase& | column |
| ) |  |  |

void Gtk::TreeViewColumn::add_attribute | ( | const Glib::PropertyProxy_Base & | property,
|  | const TreeModelColumnBase& | column |
| ) |  |  |

void Gtk::TreeViewColumn::add_attribute | ( | CellRenderer& | cell_renderer,
|  | const Glib::ustring & | attribute,
|  | int | column |
| ) |  |  |

Adds an attribute mapping to the list in tree_column.

The column is the column of the model to get a value from, and the attribute is the parameter on cell_renderer to be set from the value. So for example if column 2 of the model contains strings, you could have the "text" attribute of a Gtk::CellRendererText get its values from column 2.

Parameters:

  | cell_renderer | The Gtk::CellRenderer to set attributes on.
  | attribute | An attribute on the renderer.
  | column | The column position on the model to get the attribute from.

void Gtk::TreeViewColumn::cell_get_size | ( | const Gdk::Rectangle& | cell_area,
|  | int & | x_offset,
|  | int & | y_offset,
|  | int & | width,
|  | int & | height |
| ) |  |  | const

Obtains the width and height needed to render the column.

This is used primarily by the Gtk::TreeView.

Parameters:

  | cell_area | The area a cell in the column will be allocated.
  | x_offset | Location to return x offset of a cell relative to cell_area.
  | y_offset | Location to return y offset of a cell relative to cell_area.
  | width | Location to return width needed to render a cell.
  | height | Location to return height needed to render a cell.

void Gtk::TreeViewColumn::cell_get_size | ( | Gdk::Rectangle& | cell_area,
|  | int & | x_offset,
|  | int & | y_offset,
|  | int & | width,
|  | int & | height |
| ) |  |  | const

Obtains the width and height needed to render the column.

This is used primarily by the Gtk::TreeView.

Deprecated:
  Use the cell_get_size() method override that takes a const cell_area.

Parameters:

  | cell_area | The area a cell in the column will be allocated.
  | x_offset | Location to return x offset of a cell relative to cell_area.
  | y_offset | Location to return y offset of a cell relative to cell_area.
  | width | Location to return width needed to render a cell.
  | height | Location to return height needed to render a cell.

bool Gtk::TreeViewColumn::cell_is_visible | ( |  | ) | const

Returns `true` if any of the cells packed into the tree_column are visible.

For this to be meaningful, you must first initialize the cells with cell_set_cell_data()

Returns:
  `true`, if any of the cells packed into the tree_column are currently visible.

void Gtk::TreeViewColumn::cell_set_cell_data | ( | const Glib::RefPtr< TreeModel >& | tree_model,
|  | const TreeModel::iterator& | iter,
|  | bool | is_expander,
|  | bool | is_expanded |
| ) |  |  |

Sets the cell renderer based on the tree_model and iter.

That is, for every attribute mapping in tree_column, it will get a value from the set column on the iter, and use that value to set the attribute on the cell renderer. This is used primarily by the Gtk::TreeView.

Parameters:

  | tree_model | The Gtk::TreeModel to to get the cell renderers attributes from.
  | iter | The Gtk::TreeIter to to get the cell renderer's attributes from.
  | is_expander | `true`, if the row has children.
  | is_expanded | `true`, if the row has visible children.

void Gtk::TreeViewColumn::clear | ( |  | ) |

Unsets all the mappings on all renderers on the tree_column.

void Gtk::TreeViewColumn::clear_attributes | ( | CellRenderer& | cell_renderer | ) |

Clears all existing attributes previously set with set_attributes().

Parameters:

  | cell_renderer | A Gtk::CellRenderer to clear the attribute mapping on.

void Gtk::TreeViewColumn::clicked | ( |  | ) |

Emits the "clicked" signal on the column.

This function will only work if tree_column is clickable.

void Gtk::TreeViewColumn::focus_cell | ( | CellRenderer& | cell | ) |

Sets the current keyboard focus to be at cell, if the column contains 2 or more editable and activatable cells.

Since gtkmm 2.2:

Parameters:

  | cell | A Gtk::CellRenderer.

float Gtk::TreeViewColumn::get_alignment | ( |  | ) | const

Returns the current x alignment of tree_column.

This value can range between 0.0 and 1.0.

Returns:
  The current alignent of tree_column.

bool Gtk::TreeViewColumn::get_cell_position | ( | const CellRenderer& | cell_renderer,
|  | int & | start_pos,
|  | int & | width |
| ) |  |  | const

Obtains the horizontal position and size of a cell in a column.

If the cell is not found in the column, start_pos and width are not changed and `false` is returned.

Parameters:

  | cell_renderer | A Gtk::CellRenderer.
  | start_pos | Return location for the horizontal position of cell within tree_column.
  | width | Return location for the width of cell.

Returns:
  `true` if cell belongs to tree_column.

Glib::ListHandle<const CellRenderer*> Gtk::TreeViewColumn::get_cell_renderers | ( |  | ) | const

Returns a list of all the cell renderers in the column, in no particular order.

Returns:
  A list of Gtk::CellRenderers.

Glib::ListHandle<CellRenderer*> Gtk::TreeViewColumn::get_cell_renderers | ( |  | ) |

Returns a list of all the cell renderers in the column, in no particular order.

Returns:
  A list of Gtk::CellRenderers.

bool Gtk::TreeViewColumn::get_clickable | ( |  | ) | const

Returns `true` if the user can click on the header for the column.

Returns:
  `true` if user can click the column header.

bool Gtk::TreeViewColumn::get_expand | ( |  | ) | const

Return `true` if the column expands to take any available space.

Since gtkmm 2.4:

Returns:
  `true`, if the column expands.

const CellRenderer* Gtk::TreeViewColumn::get_first_cell_renderer | ( |  | ) | const

Gets the CellRenderer for the column.

You should dynamic_cast<> to the expected derived CellRenderer type. This assumes that the TreeViewColumn contains only one CellRenderer.

CellRenderer* Gtk::TreeViewColumn::get_first_cell_renderer | ( |  | ) |

Gets the CellRenderer for the column.

You should dynamic_cast<> to the expected derived CellRenderer type. This assumes that the TreeViewColumn contains only one CellRenderer.

int Gtk::TreeViewColumn::get_fixed_width | ( |  | ) | const

Gets the fixed width of the column.

This value is only meaning may not be the actual width of the column on the screen, just what is requested.

Returns:
  The fixed width of the column.

int Gtk::TreeViewColumn::get_max_width | ( |  | ) | const

Returns the maximum width in pixels of the tree_column, or -1 if no maximum width is set.

Returns:
  The maximum width of the tree_column.

int Gtk::TreeViewColumn::get_min_width | ( |  | ) | const

Returns the minimum width in pixels of the tree_column, or -1 if no minimum width is set.

Returns:
  The minimum width of the tree_column.

bool Gtk::TreeViewColumn::get_reorderable | ( |  | ) | const

Returns `true` if the tree_column can be reordered by the user.

Returns:
  `true` if the tree_column can be reordered by the user.

bool Gtk::TreeViewColumn::get_resizable | ( |  | ) | const

Returns `true` if the tree_column can be resized by the end user.

Returns:
  `true`, if the tree_column can be resized.

TreeViewColumnSizing Gtk::TreeViewColumn::get_sizing | ( |  | ) |

Returns the current type of tree_column.

Returns:
  The type of tree_column.

int Gtk::TreeViewColumn::get_sort_column_id | ( |  | ) | const

Gets the logical sort_column_id that the model sorts on when this column is selected for sorting.

See set_sort_column_id().

Returns:
  The current sort_column_id for this column, or -1 if this column can't be used for sorting.

bool Gtk::TreeViewColumn::get_sort_indicator | ( |  | ) | const

Gets the value set by set_sort_indicator().

Returns:
  Whether the sort indicator arrow is displayed.

SortType Gtk::TreeViewColumn::get_sort_order | ( |  | ) | const

Gets the value set by set_sort_order().

Returns:
  The sort order the sort indicator is indicating.

int Gtk::TreeViewColumn::get_spacing | ( |  | ) | const

Returns the spacing of tree_column.

Returns:
  The spacing of tree_column.

Glib::ustring Gtk::TreeViewColumn::get_title | ( |  | ) | const

Returns the title of the widget.

Returns:
  The title of the column. This string should not be modified or freed.

const TreeView* Gtk::TreeViewColumn::get_tree_view | ( |  | ) | const

Returns the Gtk::TreeView wherein tree_column has been inserted.

If column is currently not inserted in any tree view, `0` is returned.

Since gtkmm 2.12:

Returns:
  The tree view wherein column has been inserted if any, `0` otherwise.

TreeView* Gtk::TreeViewColumn::get_tree_view | ( |  | ) |

Returns the Gtk::TreeView wherein tree_column has been inserted.

If column is currently not inserted in any tree view, `0` is returned.

Since gtkmm 2.12:

Returns:
  The tree view wherein column has been inserted if any, `0` otherwise.

bool Gtk::TreeViewColumn::get_visible | ( |  | ) | const

Returns `true` if tree_column is visible.

Returns:
  Whether the column is visible or not. If it is visible, then the tree will show the column.

const Widget* Gtk::TreeViewColumn::get_widget | ( |  | ) | const

Returns the Gtk::Widget in the button on the column header.

If a custom widget has not been set then `0` is returned.

Returns:
  The Gtk::Widget in the column header, or `0`.

Widget* Gtk::TreeViewColumn::get_widget | ( |  | ) |

Returns the Gtk::Widget in the button on the column header.

If a custom widget has not been set then `0` is returned.

Returns:
  The Gtk::Widget in the column header, or `0`.

int Gtk::TreeViewColumn::get_width | ( |  | ) | const

Returns the current size of tree_column in pixels.

Returns:
  The current width of tree_column.

const GtkTreeViewColumn* Gtk::TreeViewColumn::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Object.

GtkTreeViewColumn* Gtk::TreeViewColumn::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Object.

virtual void Gtk::TreeViewColumn::on_clicked | ( |  | ) | `[protected, virtual]`

template <class T_ModelColumnType >

void Gtk::TreeViewColumn::pack_end | ( | const TreeModelColumn< T_ModelColumnType >& | column,
|  | bool | expand = `true` |
| ) |  |  | `[inline]`

Creates an appropriate CellRenderer for the column, and packs that cell at the end of the column.

If expand is `false`, then the cell is allocated no more space than it needs. Any unused space is divided evenly between cells for which expand is `true`.

You can use get_first_cell_renderer() or get_cell_renderers() to access the generated CellRenderer.

Parameters:

  | column | The model column that will be rendered by the view cell.
  | expand | `true` if the cell is to be given extra space allocated to the view column.

void Gtk::TreeViewColumn::pack_end | ( | CellRenderer& | cell,
|  | bool | expand = `true` |
| ) |  |  |

Adds the cell to end of the column.

If expand is `false`, then the cell is allocated no more space than it needs. Any unused space is divided evenly between cells for which expand is `true`.

Parameters:

  | cell | The Gtk::CellRenderer.
  | expand | `true` if cell is to be given extra space allocated to tree_column.

template <class T_ModelColumnType >

void Gtk::TreeViewColumn::pack_start | ( | const TreeModelColumn< T_ModelColumnType >& | column,
|  | bool | expand = `true` |
| ) |  |  | `[inline]`

Creates an appropriate CellRenderer for the column, and packs that cell into the beginning of the column.

If expand is `false`, then the cell is allocated no more space than it needs. Any unused space is divided evenly between cells for which expand is `true`.

You can use get_first_cell_renderer() or get_cell_renderers() to access the generated CellRenderer.

Parameters:

  | column | The model column that will be rendered by the view cell.
  | expand | `true` if the cell is to be given extra space allocated to the view column.

void Gtk::TreeViewColumn::pack_start | ( | CellRenderer& | cell,
|  | bool | expand = `true` |
| ) |  |  |

Packs the cell into the beginning of the column.

If expand is `false`, then the cell is allocated no more space than it needs. Any unused space is divided evenly between cells for which expand is `true`.

Parameters:

  | cell | The Gtk::CellRenderer.
  | expand | `true` if cell is to be given extra space allocated to tree_column.

Glib::PropertyProxy_ReadOnly<float> Gtk::TreeViewColumn::property_alignment | ( |  | ) | const

X Alignment of the column header text or widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<float> Gtk::TreeViewColumn::property_alignment | ( |  | ) |

X Alignment of the column header text or widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::TreeViewColumn::property_clickable | ( |  | ) | const

Whether the header can be clicked.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::TreeViewColumn::property_clickable | ( |  | ) |

Whether the header can be clicked.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::TreeViewColumn::property_expand | ( |  | ) | const

Column gets share of extra width allocated to the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::TreeViewColumn::property_expand | ( |  | ) |

Column gets share of extra width allocated to the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::TreeViewColumn::property_fixed_width | ( |  | ) | const

Current fixed width of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::TreeViewColumn::property_fixed_width | ( |  | ) |

Current fixed width of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::TreeViewColumn::property_max_width | ( |  | ) | const

Maximum allowed width of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::TreeViewColumn::property_max_width | ( |  | ) |

Maximum allowed width of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::TreeViewColumn::property_min_width | ( |  | ) | const

Minimum allowed width of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::TreeViewColumn::property_min_width | ( |  | ) |

Minimum allowed width of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::TreeViewColumn::property_reorderable | ( |  | ) | const

Whether the column can be reordered around the headers.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::TreeViewColumn::property_reorderable | ( |  | ) |

Whether the column can be reordered around the headers.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<TreeViewColumnSizing> Gtk::TreeViewColumn::property_sizing | ( |  | ) | const

Resize mode of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<TreeViewColumnSizing> Gtk::TreeViewColumn::property_sizing | ( |  | ) |

Resize mode of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::TreeViewColumn::property_sort_indicator | ( |  | ) | const

Whether to show a sort indicator.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::TreeViewColumn::property_sort_indicator | ( |  | ) |

Whether to show a sort indicator.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<SortType> Gtk::TreeViewColumn::property_sort_order | ( |  | ) | const

Sort direction the sort indicator should indicate.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<SortType> Gtk::TreeViewColumn::property_sort_order | ( |  | ) |

Sort direction the sort indicator should indicate.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gtk::TreeViewColumn::property_title | ( |  | ) | const

Title to appear in column header.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gtk::TreeViewColumn::property_title | ( |  | ) |

Title to appear in column header.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::TreeViewColumn::property_visible | ( |  | ) | const

Whether to display the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::TreeViewColumn::property_visible | ( |  | ) |

Whether to display the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Widget*> Gtk::TreeViewColumn::property_widget | ( |  | ) | const

Widget to put in column header button instead of column title.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Widget*> Gtk::TreeViewColumn::property_widget | ( |  | ) |

Widget to put in column header button instead of column title.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::TreeViewColumn::property_width | ( |  | ) | const

Current width of the column.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::TreeViewColumn::queue_resize | ( |  | ) |

Flags the column, and the cell renderers added to this column, to have their sizes renegotiated.

Since gtkmm 2.8:

void Gtk::TreeViewColumn::set_alignment | ( | AlignmentEnum | xalign | ) |

Sets the alignment of the title or custom widget inside the column header.

The alignment determines its location inside the button -- 0.0 for left, 0.5 for center, 1.0 for right.

Parameters:

  | xalign | The alignment, which is between [0.0 and 1.0] inclusive.

void Gtk::TreeViewColumn::set_alignment | ( | float | xalign | ) |

Sets the alignment of the title or custom widget inside the column header.

The alignment determines its location inside the button -- 0.0 for left, 0.5 for center, 1.0 for right.

Parameters:

  | xalign | The alignment, which is between [0.0 and 1.0] inclusive.

void Gtk::TreeViewColumn::set_cell_data_func | ( | CellRenderer& | cell_renderer,
|  | const SlotCellData & | slot |
| ) |  |  |

Sets the slot callback to use for the column.

This callback function is used instead of the standard attributes mapping for setting the column value, and should set the value of the column's cell renderer as appropriate.

See also unset_cell_data_func().

Parameters:

  | cell_renderer | A Gtk::CellRenderer
  | slot | The callback slot to use. Create this with sigc::mem_fun(), or sigc::ptr_fun().

void Gtk::TreeViewColumn::set_clickable | ( | bool | clickable = `true` | ) |

Sets the header to be active if active is `true`.

When the header is active, then it can take keyboard focus, and can be clicked.

Parameters:

  | clickable | `true` if the header is active.

void Gtk::TreeViewColumn::set_expand | ( | bool | expand = `true` | ) |

Sets the column to take available extra space.

This space is shared equally amongst all columns that have the expand set to `true`. If no column has this option set, then the last column gets all extra space. By default, every column is created with this `false`.

Since gtkmm 2.4:

Parameters:

  | expand | `true` if the column should take available extra space, `false` if not.

void Gtk::TreeViewColumn::set_fixed_width | ( | int | fixed_width | ) |

Sets the size of the column in pixels.

This is meaningful only if the sizing type is Gtk::TREE_VIEW_COLUMN_FIXED. The size of the column is clamped to the min/max width for the column. Please note that the min/max width of the column doesn't actually affect the "fixed_width" property of the widget, just the actual size when displayed.

Parameters:

  | fixed_width | The size to set tree_column to. Must be greater than 0.

void Gtk::TreeViewColumn::set_max_width | ( | int | max_width | ) |

Sets the maximum width of the tree_column.

If max_width is -1, then the maximum width is unset. Note, the column can actually be wider than max width if it's the last column in a view. In this case, the column expands to fill any extra space.

Parameters:

  | max_width | The maximum width of the column in pixels, or -1.

void Gtk::TreeViewColumn::set_min_width | ( | int | min_width | ) |

Sets the minimum width of the tree_column.

If min_width is -1, then the minimum width is unset.

Parameters:

  | min_width | The minimum width of the column in pixels, or -1.

void Gtk::TreeViewColumn::set_renderer | ( | Gtk::CellRenderer& | renderer,
|  | const TreeModelColumnBase& | column |
| ) |  |  |

Associate a view CellRenderer with a model column, so that the CellRenderer renders the data in the model column.

Parameters:

  | renderer | The view cell renderer which will render the model column.
  | column | The model column to be renderered by this view.

void Gtk::TreeViewColumn::set_reorderable | ( | bool | reorderable = `true` | ) |

If reorderable is `true`, then the column can be reordered by the end user dragging the header.

Parameters:

  | reorderable | `true`, if the column can be reordered.

void Gtk::TreeViewColumn::set_resizable | ( | bool | resizable = `true` | ) |

If resizable is `true`, then the user can explicitly resize the column by grabbing the outer edge of the column button.

If resizable is `true` and sizing mode of the column is Gtk::TREE_VIEW_COLUMN_AUTOSIZE, then the sizing mode is changed to Gtk::TREE_VIEW_COLUMN_GROW_ONLY.

Parameters:

  | resizable | `true`, if the column can be resized.

void Gtk::TreeViewColumn::set_sizing | ( | TreeViewColumnSizing | type | ) |

Sets the growth behavior of tree_column to type.

Parameters:

  | type | The Gtk::TreeViewColumnSizing.

void Gtk::TreeViewColumn::set_sort_column | ( | int | sort_column_id | ) |

Sets the logical sort_column_id that this column sorts on when this column is selected for sorting.

Doing so makes the column header clickable.

Parameters:

  | sort_column_id | The sort_column_id of the model to sort on.

void Gtk::TreeViewColumn::set_sort_column | ( | const TreeModelColumnBase& | sort_column_id | ) |

Sets the logical sort_column_id that this column sorts on when this column is selected for sorting.

Doing so makes the column header clickable.

Parameters:

  | sort_column_id | The sort_column_id of the model to sort on.

void Gtk::TreeViewColumn::set_sort_column_id | ( | int | sort_column_id | ) |

Deprecated:
  Use set_sort_column() instead.

void Gtk::TreeViewColumn::set_sort_column_id | ( | const TreeModelColumnBase& | sort_column_id | ) |

Deprecated:
  Use set_sort_column() instead.

void Gtk::TreeViewColumn::set_sort_indicator | ( | bool | setting | ) |

Call this function with a setting of `true` to display an arrow in the header button indicating the column is sorted.

Call set_sort_order() to change the direction of the arrow.

Parameters:

  | setting | `true` to display an indicator that the column is sorted.

void Gtk::TreeViewColumn::set_sort_order | ( | SortType | order | ) |

Changes the appearance of the sort indicator.

This <emphasis>does not</emphasis> actually sort the model. Use set_sort_column_id() if you want automatic sorting support. This function is primarily for custom sorting behavior, and should be used in conjunction with gtk_tree_sortable_set_sort_column() to do that. For custom models, the mechanism will vary.

The sort indicator changes direction to indicate normal sort or reverse sort. Note that you must have the sort indicator enabled to see anything when calling this function; see set_sort_indicator().

Parameters:

  | order | Sort order that the sort indicator should indicate.

void Gtk::TreeViewColumn::set_spacing | ( | int | spacing | ) |

Sets the spacing field of tree_column, which is the number of pixels to place between cell renderers packed into it.

Parameters:

  | spacing | Distance between cell renderers in pixels.

void Gtk::TreeViewColumn::set_title | ( | const Glib::ustring & | title | ) |

Sets the title of the tree_column.

If a custom widget has been set, then this value is ignored.

Parameters:

  | title | The title of the tree_column.

void Gtk::TreeViewColumn::set_visible | ( | bool | visible = `true` | ) |

Sets the visibility of tree_column.

Parameters:

  | visible | `true` if the tree_column is visible.

void Gtk::TreeViewColumn::set_widget | ( | Gtk::Widget& | widget | ) |

Sets the widget in the header to be widget.

If widget is `0`, then the header button is set with a Gtk::Label set to the title of tree_column.

Parameters:

  | widget | A child Gtk::Widget, or `0`.

Glib::SignalProxy0< void > Gtk::TreeViewColumn::signal_clicked | ( |  | ) |

Prototype:
  `void on_my_clicked()`

void Gtk::TreeViewColumn::unset_cell_data_func | ( | CellRenderer& | cell_renderer | ) |

Removes a previously set callback slot.

See set_cell_data_func().

## Friends And Related Function Documentation

Gtk::TreeViewColumn* wrap | ( | GtkTreeViewColumn * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/treeviewcolumn.h